uav 11258 String Partition (DP)

来源:互联网 发布:仿苹果软件 编辑:程序博客网 时间:2024/05/16 05:59
Problem F - String Partition
                                                                                                                   Time limit: 3.000 seconds

John was absurdly busy for preparing a programming contest recently. He wanted to create a ridiculously easy problem for the contest. His problem was not only easy, but also boring: Given a list of non-negative integers, what is the sum of them?

However, he made a very typical mistake when he wrote a program to generate the input data for his problem. He forgot to print out spaces to separate the list of integers. John quickly realized his mistake after looking at the generated input file because each line is simply a string of digits instead of a list of integers.

He then got a better idea to make his problem a little more interesting: There are many ways to split a string of digits into a list of non-zero-leading (0 itself is allowed) 32-bit signed integers. What is the maximum sum of the resultant integers if the string is split appropriately?

Input
The input begins with an integer N ( 500) which indicates the number of test cases followed. Each of the following test cases consists of a string of at most 200 digits.

Output
For each input, print out required answer in a single line.

Sample input
6
1234554321
5432112345
000
121212121212
2147483648
11111111111111111111111111111111111111111111111111111

Sample output
1234554321
543211239
0
2121212124
214748372
5555555666
 
 
题意:给定一个字符串序列,让你把它划分成几个int型的数字,并且使这些数字之和最大。
 
思路:dp[i]表示前i个字符划分时的和的最大值。
dp[i] = max(dp[i], dp[i-j]+num),num为从后往前划分为j长度的数字。
 
 
 
#include <iostream>#include <cstdio>#include <cstring>#include <cmath>#include <string>#include <climits>#define LL long longusing namespace std;const LL inf=INT_MAX;const int maxn=210;LL dp[maxn];string str;void initial(){    memset(dp,0,sizeof(dp));}void input(){    cin>>str;}int get_num(char ch){    return ch-'0';}void solve(){    int len=str.size();    dp[1]=get_num(str[0]);    for(int i=2;i<=len;i++)    {         LL tmp=1,now=0;         for(int k=i-1,j=1;k>=0;k--,j++)         {              now=get_num(str[k])*tmp+now;              if(now>inf)  break;              dp[i]=max(dp[i],dp[i-j]+now);              tmp*=10;         }    }    printf("%lld\n",dp[len]);}int main(){    int T;    scanf("%d",&T);    while(T--)    {         initial();         input();         solve();    }    return 0;}

0 0
原创粉丝点击